/* $Id: SECSFileFilter.java,v 1.2 2004/06/20 15:23:40 fukasawa Exp $ */

/**
 *  @file    SECSFileFilter.java
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2001-2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

package com.jyugem.jsunit.gui;

import java.io.File;
import java.util.Hashtable;
import java.util.Enumeration;
import javax.swing.*;
import javax.swing.filechooser.*;

public class SECSFileFilter extends FileFilter {

    private Hashtable m_filters = null;
    private String    m_description;

    // Construct the filter
    public SECSFileFilter() {
        this.m_filters = new Hashtable(1);
        m_filters.put("xml", this);
        m_description = "SECS Test File (*.xml)";
    }

    public boolean accept(File f) {
        if (f != null) {
            if (f.isDirectory()) {
                return true;
            }
            String extension = getExtension(f);
            if (extension != null && m_filters.get(extension) != null) {
                return true;
            }
        }
        return false;
    }

    public String getExtension(File f) {
        if (f != null) {
            String filename = f.getName();
            int i = filename.lastIndexOf('.');
            if (i > 0 && i < (filename.length() - 1)) {
                return filename.substring(i+1).toLowerCase();
            }
        }
        return null;
    }

    public String getDescription() {
        return m_description;
    }
}
