/* $Id: SECSTestSuite.java,v 1.4 2004/06/20 15:23:40 fukasawa Exp $ */

/**
 *  @file    SECSTestCase.java
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2001-2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package com.jyugem.jsunit.tfw;

import java.util.Enumeration;
import junit.framework.*;
import java.lang.reflect.*;
import org.apache.oro.text.regex.*;
import org.w3c.dom.Node;
import com.jyugem.secs.*;

/**
 * Some simple tests.
 *
 */
public class SECSTestSuite extends TestSuite {
    protected SECSTestManager m_manager = null;
    protected String  m_methodName;
    protected String  m_description;

    public SECSTestSuite(String name, String description) {
        super(name);
        m_description = description;
    }

    public void setManager(SECSTestManager mngr) {
        m_manager = mngr;
        for (Enumeration e= tests(); e.hasMoreElements(); ) {
            Test test= (Test)e.nextElement();
            if (test instanceof SECSTestCase) {
                SECSTestCase testcase = (SECSTestCase)test;
                testcase.setManager(mngr);
            }
        }
    }

    public void   setDescription(String description) { m_description = description; }
    public String getDescription() { return m_description; }

    public String toXmlString() {
        String xml = "<secs:testsuite name=\"" + getName() + "\" description=\"" +
                     m_description + "\">";
        for (Enumeration e= tests(); e.hasMoreElements(); ) {
            Test test= (Test)e.nextElement();
            if (test instanceof SECSTestCase) {
                SECSTestCase testcase = (SECSTestCase)test;
                xml += testcase.toXmlString();
            }
        }
        xml += "</secs:testsuite>";
        return xml;
    }


    public String toString() {
        return getName() + " : " + m_description;
    }
}
